"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.RouteContext = RouteContext;
exports.RootRoute = RootRoute;

function _react() {
  const data = _interopRequireWildcard(require("react"));

  _react = function () {
    return data;
  };

  return data;
}

function _reactRouterDom() {
  const data = require("react-router-dom");

  _reactRouterDom = function () {
    return data;
  };

  return data;
}

function _uiRouting() {
  const data = require("@teambit/ui.routing.provider");

  _uiRouting = function () {
    return data;
  };

  return data;
}

function _uiReactRouter() {
  const data = require("@teambit/ui.react-router.slot-router");

  _uiReactRouter = function () {
    return data;
  };

  return data;
}

function _reactRouterRouting() {
  const data = require("./react-router-routing");

  _reactRouterRouting = function () {
    return data;
  };

  return data;
}

function _routingMethod() {
  const data = require("./routing-method");

  _routingMethod = function () {
    return data;
  };

  return data;
}

/**
 * Setup context needed for routing.
 */
function RouteContext({
  reactRouterUi,
  routing = _routingMethod().Routing.url,
  children,
  location
}) {
  return (
    /*#__PURE__*/
    // {/* set up the virtual router (browser, inMemory, etc) */}
    _react().default.createElement(Router, {
      type: routing,
      location: location
    }, /*#__PURE__*/_react().default.createElement(HistoryGetter, {
      onRouterChange: reactRouterUi.setRouter
    }), /*#__PURE__*/_react().default.createElement(_uiRouting().RoutingProvider, {
      value: _reactRouterRouting().reactRouterRouting
    }, children))
  );
}

function RootRoute({
  rootRoutes,
  routeSlot
}) {
  return /*#__PURE__*/_react().default.createElement(_uiReactRouter().SlotRouter, {
    slot: routeSlot,
    rootRoutes: rootRoutes
  });
}
/** provides the router engine (browser, inMemory, etc) */


function Router({
  type,
  children,
  location
}) {
  switch (type) {
    case _routingMethod().Routing.static:
      return /*#__PURE__*/_react().default.createElement(_reactRouterDom().StaticRouter, {
        location: location
      }, children);

    case _routingMethod().Routing.inMemory:
      return /*#__PURE__*/_react().default.createElement(_reactRouterDom().MemoryRouter, {
        initialEntries: [location || '/'],
        initialIndex: 1
      }, children);

    case _routingMethod().Routing.hash:
      return /*#__PURE__*/_react().default.createElement(_reactRouterDom().HashRouter, null, children);

    case _routingMethod().Routing.url:
    default:
      return /*#__PURE__*/_react().default.createElement(_reactRouterDom().BrowserRouter, null, children);
  }
}
/**
 * Calls onRouterChange when routing History object changes.
 * Used to inject history back into reactRouterUi
 * (needs to be rendered inside of <BrowserRouter/>)
 */


function HistoryGetter({
  onRouterChange
}) {
  const history = (0, _reactRouterDom().useHistory)();
  (0, _react().useEffect)(() => onRouterChange(history), [history]);
  return null;
}

//# sourceMappingURL=route-context.js.map